# Enum Class Modifier

java.lang.Object
java.lang.Enum<Modifier>
javax.lang.model.element.Modifier

All Implemented Interfaces:
  `Serializable, Comparable<Modifier>, Constable`

public enum Modifier extends Enum<Modifier>
Represents a modifier on a program element such as a class, method, or field.

Not all modifiers are applicable to all kinds of elements. When two or more modifiers appear in the source code of an element then it is customary, though not required, that they appear in the same order as the constants listed in the detail section below.

Note that it is possible additional modifiers will be added in future versions of the platform.

See Java Language Specification:
  8.1.1 Class Modifiers
  8.3.1 Field Modifiers
  8.4.3 Method Modifiers
  8.8.3 Constructor Modifiers
  9.1.1 Interface Modifiers
Since:
  1.6

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ABSTRACT`
  The modifier `abstract`
  `DEFAULT`
  The modifier `default`
  `FINAL`
  The modifier `final`
  `NATIVE`
  The modifier `native`
  `NON_SEALED`
  The modifier `non-sealed`
  `PRIVATE`
  The modifier `private`
  `PROTECTED`
  The modifier `protected`
  `PUBLIC`
  The modifier `public`
  `SEALED`
  The modifier `sealed`
  `STATIC`
  The modifier `static`
  `STRICTFP`
  The modifier `strictfp`
  `SYNCHRONIZED`
  The modifier `synchronized`
  `TRANSIENT`
  The modifier `transient`
  `VOLATILE`
  The modifier `volatile`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `toString()`
  Returns this modifier's name as defined in The Java Language Specification.
  `static Modifier`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static Modifier[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(Modifier o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<Modifier>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<Modifier>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### PUBLIC

    public static final Modifier PUBLIC
    The modifier `public`
    See Java Language Specification:
      6.6 Access Control

  - ### PROTECTED

    public static final Modifier PROTECTED
    The modifier `protected`
    See Java Language Specification:
      6.6 Access Control

  - ### PRIVATE

    public static final Modifier PRIVATE
    The modifier `private`
    See Java Language Specification:
      6.6 Access Control

  - ### ABSTRACT

    public static final Modifier ABSTRACT
    The modifier `abstract`
    See Java Language Specification:
      8.1.1.1 `abstract` Classes
      8.4.3.1 `abstract` Methods
      9.1.1.1 `abstract` Interfaces

  - ### DEFAULT

    public static final Modifier DEFAULT
    The modifier `default`
    See Java Language Specification:
      9.4 Method Declarations
    Since:
      1.8

  - ### STATIC

    public static final Modifier STATIC
    The modifier `static`
    See Java Language Specification:
      8.1.1.4 `static` Classes
      8.3.1.1 `static` Fields
      8.4.3.2 `static` Methods
      9.1.1.3 `static` Interfaces

  - ### SEALED

    public static final Modifier SEALED
    The modifier `sealed`
    See Java Language Specification:
      8.1.1.2 `sealed`, `non-sealed`, and `final` Classes
      9.1.1.4 `sealed` and `non-sealed` Interfaces
    Since:
      17

  - ### NON_SEALED

    public static final Modifier NON_SEALED
    The modifier `non-sealed`
    See Java Language Specification:
      8.1.1.2 `sealed`, `non-sealed`, and `final` Classes
      9.1.1.4 `sealed` and `non-sealed` Interfaces
    Since:
      17

  - ### FINAL

    public static final Modifier FINAL
    The modifier `final`
    See Java Language Specification:
      8.1.1.2 `sealed`, `non-sealed`, and `final` Classes
      8.3.1.2 `final` Fields
      8.4.3.3 `final` Methods

  - ### TRANSIENT

    public static final Modifier TRANSIENT
    The modifier `transient`
    See Java Language Specification:
      8.3.1.3 `transient` Fields

  - ### VOLATILE

    public static final Modifier VOLATILE
    The modifier `volatile`
    See Java Language Specification:
      8.3.1.4 `volatile` Fields

  - ### SYNCHRONIZED

    public static final Modifier SYNCHRONIZED
    The modifier `synchronized`
    See Java Language Specification:
      8.4.3.6 `synchronized` Methods

  - ### NATIVE

    public static final Modifier NATIVE
    The modifier `native`
    See Java Language Specification:
      8.4.3.4 `native` Methods

  - ### STRICTFP

    public static final Modifier STRICTFP
    The modifier `strictfp`
    See Java Language Specification:
      8.1.1.3 `strictfp` Classes
      8.4.3.5 `strictfp` Methods
      9.1.1.2 `strictfp` Interfaces

- ## Method Details

  - ### values

    public static Modifier[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static Modifier valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### toString

    public String toString()
    Returns this modifier's name as defined in The Java Language Specification. The modifier name is the name of the enum constant in lowercase and with any underscores ("`_`") replaced with hyphens ("`-`").
    Overrides:
      `toString` in class `Enum<Modifier>`
    Returns:
      the modifier's name